//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by Entitas.CodeGeneration.Plugins.ComponentEntityApiGenerator.
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------
public partial class GameEntity {

    public HoverListenerComponent hoverListener { get { return (HoverListenerComponent)GetComponent(GameComponentsLookup.HoverListener); } }
    public bool hasHoverListener { get { return HasComponent(GameComponentsLookup.HoverListener); } }

    public void AddHoverListener(System.Collections.Generic.List<IHoverListener> newValue) {
        var index = GameComponentsLookup.HoverListener;
        var component = CreateComponent<HoverListenerComponent>(index);
        component.value = newValue;
        AddComponent(index, component);
    }

    public void ReplaceHoverListener(System.Collections.Generic.List<IHoverListener> newValue) {
        var index = GameComponentsLookup.HoverListener;
        var component = CreateComponent<HoverListenerComponent>(index);
        component.value = newValue;
        ReplaceComponent(index, component);
    }

    public void RemoveHoverListener() {
        RemoveComponent(GameComponentsLookup.HoverListener);
    }
}

//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by Entitas.CodeGeneration.Plugins.ComponentMatcherApiGenerator.
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------
public sealed partial class GameMatcher {

    static Entitas.IMatcher<GameEntity> _matcherHoverListener;

    public static Entitas.IMatcher<GameEntity> HoverListener {
        get {
            if (_matcherHoverListener == null) {
                var matcher = (Entitas.Matcher<GameEntity>)Entitas.Matcher<GameEntity>.AllOf(GameComponentsLookup.HoverListener);
                matcher.componentNames = GameComponentsLookup.componentNames;
                _matcherHoverListener = matcher;
            }

            return _matcherHoverListener;
        }
    }
}

//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by Entitas.CodeGeneration.Plugins.EventEntityApiGenerator.
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------
public partial class GameEntity {

    public void AddHoverListener(IHoverListener value) {
        var listeners = hasHoverListener
            ? hoverListener.value
            : new System.Collections.Generic.List<IHoverListener>();
        listeners.Add(value);
        ReplaceHoverListener(listeners);
    }

    public void RemoveHoverListener(IHoverListener value, bool removeComponentWhenEmpty = true) {
        var listeners = hoverListener.value;
        listeners.Remove(value);
        if (removeComponentWhenEmpty && listeners.Count == 0) {
            RemoveHoverListener();
        } else {
            ReplaceHoverListener(listeners);
        }
    }
}
